/* install.js, for ReGet Plugin
 * borrowed from the Tabbrowser Preferences extension
 *
 * verifyDiskSpace() is borrowed from the original
 * install.js
 */
var author      = "Marek Wawoczny"
var displayname = "ReGet Plugin for Mozilla";
var version     = "0.9";
var packagename = "reget";
var packagefile = packagename + ".jar";
var packagesize = "865";

var cflag       = CONTENT | PROFILE_CHROME;
var error       = null;
var installdir  = getFolder("Current User", "chrome");
var folder      = null;

var msg = "Do you wish to install the ReGet Plugin " + version + " into the profile directory (OK) or the browser directory (Cancel)?";
var ok = confirm(msg);
if(!ok) {
  cflag = CONTENT | DELAYED_CHROME;
  installdir = getFolder("chrome");
}

// Begin the installation
initInstall(displayname + " " + version, "/" + author + "/" + displayname, version);
setPackageFolder(installdir);
error = addFile(packagename, version, "chrome/" + packagefile, installdir, null);

if(error == SUCCESS) {
  folder = getFolder(installdir, packagefile);
  
  // Verify that there is sufficient disk space
  if(verifyDiskSpace(installdir, packagesize))
  {
  	 cancelInstall(INSUFFICENT_DISK_SPACE);
  }

  // Register the chrome content
  registerChrome(cflag, folder, "content/" + packagename + "/");
 
  // Install the extension
  if(getLastError() == SUCCESS)
  {
    error = performInstall();
    if(error) {
      alert("An error occured during installation !\nErrorcode: " + error);
    }
  }
  else
  {
    alert("An error occurred, installation will be cancelled.\nErrorcode: " + error);
    cancelInstall(error);
  }
}

function verifyDiskSpace(dirPath, spaceRequired)
{
  var spaceAvailable;
  spaceAvailable = fileGetDiskSpaceAvailable(dirPath);
  spaceAvailable = parseInt(spaceAvailable / 1024);

  if(spaceAvailable < spaceRequired) 
  {
    logComment("Insufficient disk space: " + dirPath);
    logComment("  required : " + spaceRequired + " K");
    logComment("  available: " + spaceAvailable + " K");
    return (false);
  }

  return (true);
}
